commit 51df90d7fca8c96f35f71dc1bb4d2ecf7f820e70
Author: Christophe Lyon <christophe.lyon@arm.com>
Date:   Mon Oct 3 12:26:03 2022

    arm: Add missing early clobber to MVE vrev64q_m patterns
    
    Like the non-predicated vrev64q patterns, mve_vrev64q_m_<supf><mode>
    and mve_vrev64q_m_f<mode> need an early clobber constraint, otherwise
    we can generate an unpredictable instruction:
    
    Warning: 64-bit element size and same destination and source operands makes instruction UNPREDICTABLE
    when calling vrevq64_m* with the same first and second arguments.
    
    OK for trunk?
    
    Thanks,
    
    Christophe
    
    gcc/ChangeLog:
    
            * config/arm/mve.md (mve_vrev64q_m_<supf><mode>): Add early
            clobber.
            (mve_vrev64q_m_f<mode>): Likewise.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/arm/mve/intrinsics/vrev64q_m_s16-clobber.c: New test.
    
    (cherry picked from commit 06aa66af7d0dacc1b247d9e38175e789ef159191)

diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vrev64q_m_s16-clobber.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vrev64q_m_s16-clobber.c
new file mode 100644
index 00000000000..6464c96181d
--- /dev/null
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vrev64q_m_s16-clobber.c
@@ -0,0 +1,17 @@
+/* { dg-require-effective-target arm_v8_1m_mve_fp_ok } */
+/* { dg-add-options arm_v8_1m_mve_fp } */
+/* { dg-additional-options "-O2" } */
+
+#include "arm_mve.h"
+
+int16x8_t
+foo (int16x8_t a, mve_pred16_t p)
+{
+  return vrev64q_m_s16 (a, a, p);
+}
+
+float16x8_t
+foo2 (float16x8_t a, mve_pred16_t p)
+{
+  return vrev64q_m_f16 (a, a, p);
+}

